/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	MemoryFile.cpp
 *
 *****************************************************************************/

// SOL++2000

#include <sol\MemoryFile.h>


MemoryFile::MemoryFile()
	:File() 
{ 
	hmap 		= NULL;
	buff 		= NULL;
	writable 	= FALSE;
	size		= 0;
			
}

BOOL MemoryFile::create(const char* name, BOOL writeFlag, int len) 
{
	writable = writeFlag;
	size     = len;		
	BOOL result = File::create(name);
	if(result) {
		HANDLE fh = getHandle();
	  	hmap = ::CreateFileMapping(fh, 
							0,
							PAGE_READWRITE,
							0l, 
							size,
							NULL);
		if(hmap) {
			buff = (char*)::MapViewOfFile(hmap, 
								FILE_MAP_WRITE,
								0,
								0,
								size);	
		}
		if(hmap == NULL || buff == NULL) {
			 result = FALSE;
		}
	}
	return result;
}

	
MemoryFile::~MemoryFile() 
{
	close();
}


void MemoryFile::close()
{
	if(buff) {
		::UnmapViewOfFile(hmap);
	}
	if(writable) {
		 seek(size, FILE_BEGIN);
	}		 
	setEnd();
	File::close();
}

