/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	FileDialog.cpp
 *
 *****************************************************************************/


// SOL++2000 
// 2000.02.18


#include <sol\ApplicationView.h>
#include <sol\ScrolledText.h>
#include <sol\FileDialog.h>

#include "MenuID.h"


class AppView :public ApplicationView {
	ScrolledText   sctext;
	FileDialog		filedlg;
	FileDialog		savedlg;

	void	open(Action& action)
	{
		filedlg.popup(action);
		if (action.getResult()) {
			sctext.load(filedlg.getFileName());
		}
	}

	void	save(Action& action)
	{
		savedlg.popup(action);
		if (action.getResult()) {
			sctext.save(savedlg.getFileName());
		}
	}

  public:
	AppView(Application& applet, const char* name, Args& args)
		:ApplicationView(applet, name, args) 
	{
		Args ar;
		sctext.create(this, "", ar);

		add(&sctext);

		ar.reset();
		ar.set(XmNaccessMode, FileDialog::OPEN);
		filedlg.create(this, NULL, ar);

		ar.reset();
		ar.set(XmNaccessMode, FileDialog::SAVE);
		savedlg.create(this, NULL, ar);

		addCallback(XmNmenuCallback, ID_OPEN, this, (Callback)&AppView::open, NULL);
		addCallback(XmNmenuCallback, ID_SAVE, this, (Callback)&AppView::save, NULL);
		addCallback(XmNmenuCallback, ID_EXIT, this, (Callback)&AppView::exit, NULL);
	}
};



void	Main(int argc, char** argv)
{
	const char* name = "AppView";
	Application applet(name, argc, argv);
	Args args;
	AppView appView(applet, name, args);
	appView.realize();
	applet.run();
}
