/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	StrDef.h
 *
 *****************************************************************************/

// SOL++2000

// Note: The XmN* notation is from OSF/Motif.

#include <sol\auxdef.h>

#ifndef _STRDEF
#define _STRDEF

extern const char* XmNaccessMode;
extern const char* XmNacceleratorName;
extern const char* XmNacceptFiles;
extern const char* XmNactivateCallback;
extern const char* XmNalignment;
extern const char* XmNapplyCallback;
extern const char* XmNarmCallback;
extern const char* XmNbackground;
extern const char* XmNbeginEditCallback;

extern const char* XmNbitmap;
extern const char* XmNborderWidth;
extern const char* XmNbrowseSelectionCallback;
extern const char* XmNcancelCallback;
extern const char* XmNcharSet;
extern const char* XmNchildId;
extern const char* XmNclassName;
extern const char* XmNclassStyle;
extern const char* XmNclipPrecision;
extern const char* XmNclsExtra;
extern const char* XmNcolumn;
extern const char* XmNcursor;
extern const char* XmNcustomFilter;
extern const char* XmNdataType;
extern const char* XmNdc;
extern const char* XmNdefaultActionCallback;
//extern const char* XmNdeleteItemCallback;

extern const char* XmNdialogUnit;
extern const char* XmNdialogTitle;
extern const char* XmNdirectory;
extern const char* XmNdisableNoScroll;
extern const char* XmNdisabled;
extern const char* XmNdirection;

extern const char* XmNdragBeginCallback;
extern const char* XmNdragFinishedCallback;
extern const char* XmNendEditCallback;

extern const char* XmNescapement;
extern const char* XmNexposeCallback;
extern const char* XmNexStyle;
extern const char* XmNextendedSel;

extern const char* XmNextension;

extern const char* XmNfaceName;
extern const char* XmNfileName;
extern const char* XmNfileTitle;
extern const char* XmNfilter;
extern const char* XmNfilterIndex;
extern const char* XmNfindString;

extern const char* XmNflags;
extern const char* XmNforeground;
extern const char* XmNframe;
extern const char* XmNgroup;
extern const char* XmNheight;
extern const char* XmNhelpCallback;
extern const char* XmNhook;
extern const char* XmNhorizScrollBar;
extern const char* XmNhorizScrollCallback;
extern const char* XmNhorizScrollMaximum;
extern const char* XmNhorizScrollMinimum;
extern const char* XmNhorizThumbPosition;
extern const char* XmNicon;
extern const char* XmNiconFile;
extern const char* XmNid;

extern const char* XmNinstance;
extern const char* XmNinvert;
extern const char* XmNitalic;
extern const char* XmNitemCount;
extern const char* XmNitems;
extern const char* XmNitemsList;
extern const char* XmNlabel;
extern const char* XmNlabelString;
extern const char* XmNlabelType;
extern const char* XmNlabelWidth;
extern const char* XmNlineIncrement;
extern const char* XmNloader;
extern const char* XmNlogicalFont;
extern const char* XmNlowerCase;

extern const char* XmNmargin;
extern const char* XmNmaximum;
extern const char* XmNmaxLength;
extern const char* XmNmdiChild;
extern const char* XmNmdiClientStyle;
extern const char* XmNmenuCallback;
extern const char* XmNmenuId;
extern const char* XmNmenuList;
extern const char* XmNmenuName;
extern const char* XmNminimum;
extern const char* XmNmultiColumn;
extern const char* XmNmultiLine;
extern const char* XmNmultipleSel;
extern const char* XmNnoConfiguration;
extern const char* XmNnoHideSel;
extern const char* XmNnoPrefix;

extern const char* XmNoemConvert;

extern const char* XmNokCallback;
extern const char* XmNorientation;
extern const char* XmNoutputPrecision;
extern const char* XmNpageIncrement;
extern const char* XmNparam;
extern const char* XmNpassword;

extern const char* XmNpattern;
extern const char* XmNpitchAndFamily;
extern const char* XmNpredefined;
extern const char* XmNquality;
extern const char* XmNreadOnly;

extern const char* XmNrecomputeSize;
extern const char* XmNreplaceString;
extern const char* XmNrgbResult;

extern const char* XmNscrollBar;
extern const char* XmNselChangeCallback;

extern const char* XmNshadow;
extern const char* XmNsortItems;
extern const char* XmNspacing;
extern const char* XmNstrikeout;
extern const char* XmNstyle;
extern const char* XmNtabStop;

extern const char* XmNtemplateName; 
extern const char* XmNthickness;
extern const char* XmNthumbPosition;
extern const char* XmNtype;
extern const char* XmNunderline;
extern const char* XmNupperCase;

extern const char* XmNuseTabStops;
extern const char* XmNvertScrollBar;
extern const char* XmNvertScrollCallback;
extern const char* XmNvertScrollMaximum;
extern const char* XmNvertScrollMinimum;
extern const char* XmNvertThumbPosition;
extern const char* XmNvalue;
extern const char* XmNvisible;
extern const char* XmNwantKeyboardInput;
extern const char* XmNweight;
extern const char* XmNwidth;
extern const char* XmNwindowIcon;
extern const char* XmNwndExtra;
extern const char* XmNwndProc;
extern const char* XmNx;
extern const char* XmNy;

extern const char* XmNfocusId;

extern const char* XmNchangeCallback;
extern const char* XmNerrorSpaceCallback;
extern const char* XmNkillFocusCallback;
extern const char* XmNmaxTextCallback;
extern const char* XmNsetFocusCallback;
extern const char* XmNupdateCallback;

extern const char* XmNcloseUpCallback;
extern const char* XmNdropDownCallback;
extern const char* XmNeditChangeCallback;
extern const char* XmNeditUpdateCallback;

extern const char* XmNselEndCancelCallback;
extern const char* XmNselEndOkCallback;

extern const char* XmNselCancelCallback;
extern const char* XmNfileSave;

// TabControl
extern const char* XmNkeyDownCallback;
extern const char* XmNselChangeCallback;
extern const char* XmNselChangingCallback;

// TreeView CommonControl callbacks
extern const char* 	XmNgetDispInfoCallback;
extern const char*	XmNbeginLabelEditCallback;
extern const char*	XmNendLabelEditCallback;
extern const char*	XmNbeginDragCallback;
extern const char*	XmNbeginRDragCallback;
extern const char*	XmNitemExpandingCallback;
extern const char*	XmNitemExpandedCallback;
extern const char*	XmNdeleteItemCallback;
extern const char*	XmNkeyDownCallback;

// PropertyDialog
extern const char*	XmNstartPage;	
extern const char*	XmNpages;

// PropertyPage
extern const char*	XmNsetActiveCallback;
extern const char*	XmNkillActiveCallback;
extern const char*	XmNresetCallback;
extern const char*	XmNhasHelpCallback;
extern const char*	XmNhelpCallback;
extern const char*	XmNwizBackCallback;
extern const char*	XmNwizNextCallback;
extern const char*	XmNwizFinishCallback;
extern const char*	XmNqueryCancelCallback;

// SOL++1.2 ListView
extern const char* XmNitemChangingCallback;
extern const char* XmNitemChangedCallback;
extern const char* XmNinsertItemCallback;
extern const char* XmNenableEditCallback;
extern const char* XmNdeleteAllItemsCallback;
extern const char* XmNcolumnClickCallback;
extern const char* XmNsetDispInfoCallback;

extern const char* XmNselChangingCallback;	
extern const char* XmNselChangedCallback;

extern const char* XmNitemClickCallback;
extern const char* XmNitemDoubleClickCallback;
extern const char* XmNdividerDoubleClickCallback;
extern const char* XmNbeginTrackCallback;
extern const char* XmNendTrackCallback;
extern const char* XmNtrackCallback;

extern const char* XmNgetButtonInfoCallback;
extern const char* XmNbeginDragCallback;
extern const char* XmNendDragCallback;
extern const char* XmNbeginAdjustCallback;
extern const char* XmNendAdjustCallback;
extern const char* XmNresetCallback;
extern const char* XmNqueryInsertCallback;
extern const char* XmNqueryDeleteCallback;

extern const char* XmNtoolbarChangeCallback;
extern const char* XmNcustHelpCallback;
extern const char* XmNgetButtonInfoCallback;

extern const char* XmNenableThumbTrack;
extern const char* XmNtoolBarBitmapID;
extern const char* XmNdefaultToolBar;
extern const char* XmNdefaultStatusBar;

extern const char* XmNnumBitmaps;

extern const char* XmNneedTextCallback;
extern const char* XmNpopupCallback;
extern const char* XmNshowCallback;

extern const char* XmNcorrectTextCallback;
extern const char* XmNdropFilesCallback;
extern const char* XmNmsgFilterCallback;
extern const char* XmNprotectedCallback;
extern const char* XmNrequestResizeCallback;
extern const char* XmNstopNoUndoCallback;

extern const char* XmNdeltaPosCallback;

extern const char* XmNclickCallback;
extern const char* XmNdoubleClickCallback;
extern const char* XmNreturnCallback;
extern const char* XmNrightClickCallback;
extern const char* XmNrightDoubleClickCallback;


// SOL++ 2.1
extern const char* XmNimageName;
extern const char* XmNxImageSize;
extern const char* XmNyImageSize;
extern const char* XmNkeyInCallback;
extern const char* XmNcentering;

#endif

